        TITLE   Book psraX86.asm - Packed Shift Right Arithmetic (X86)
        PAGE    53,160

;
; psraX86.asm - Packed Shift Right Arithmetic
;
; This document contains file that you may use at your own risk in your own programs.
;
; This module is designed to accomodate X86 processors in the book.
;
;       NOTE: Needs masm 6.14 or later!
;
;       Created - 19 Dec 2001 - J.Leiterman
;
;       Modifications
;
;               
;
;       Tabs = 8



        .XLIST

        .387
        .686P
        .MMX
;       .K3D
        .model flat, C

        include x86.inc
        include KariType.inc
 
        .LIST



        .data

externdef       llMaskBQ:qword
;;;externdef    lMaskHQ:qword

lMaskHQ dq      0ff00ff00ff00ff00h



psraX86  SEGMENT USE32 PUBLIC 'CODE'



;_________________________________________________________________________________________________
;=================================================================================================
;       Packed Shift Right Arithmetic 16x8bit by n:{0...7}
;
;void vmp_psraBGeneric( int8 * const pbD, const int8 * const pbA, uint count )
;{
;       int32 val, *pA;
;       uint32 *pD;
;
;       pA = (int32*)pbA;
;       pD = (uint32*)pbD;
;
;       count &= (8-1);                         // Clip count to data bit size -1
;
;       val = *(pA+0);
;       *(pD+0) = (((uint32)((val<<24) >> count)) >> 24)
;               | ((((uint32)((val<<16) >> count)) >> 16) & 0x0000FF00)
;               | ((((uint32)((val<< 8) >> count)) >>  8) & 0x00FF0000)
;               | ((val >> count) & 0xFF000000);
;
;       val = *(pA+1);
;       *(pD+1) = (((uint32)((val<<24) >> count)) >> 24)
;               | ((((uint32)((val<<16) >> count)) >> 16) & 0x0000FF00)
;               | ((((uint32)((val<< 8) >> count)) >>  8) & 0x00FF0000)
;               | ((val >> count) & 0xFF000000);
;
;       val = *(pA+2);
;       *(pD+2) = (((uint32)((val<<24) >> count)) >> 24)
;               | ((((uint32)((val<<16) >> count)) >> 16) & 0x0000FF00)
;               | ((((uint32)((val<< 8) >> count)) >>  8) & 0x00FF0000)
;               | ((val >> count) & 0xFF000000);
;
;       val = *(pA+3);
;       *(pD+3) = (((uint32)((val<<24) >> count)) >> 24)
;               | ((((uint32)((val<<16) >> count)) >> 16) & 0x0000FF00)
;               | ((((uint32)((val<< 8) >> count)) >>  8) & 0x00FF0000)
;               | ((val >> count) & 0xFF000000);
;
;}                                                                      
;       NOTE: As X86 packed shifting only supports 16/32/64 bits we have to mask for 8bit!
;
;       *** MMX version *** 128bit (un)aligned

        public  vmp_psraBAsmMMX
vmp_psraBAsmMMX       proc    near pbD:ptr, pbA:ptr, count:DWORD
        .MMX    
ASSERT_PTR(pbD)
ASSERT_PTR(pbA)

        mov     ecx,dword ptr count             ; # of bits to shift
        mov     eax,pbA
        mov     edx,pbD
        and     ecx,8-1                         ; Clip count to 0...7 bits

        movq    mm0,[eax+0]                     ; Read Data
        movq    mm1,[eax+8]                             
        movq    mm2,mm0
        movq    mm3,mm1

        movd    mm4,ecx

        ; mm0=64bits mm1=64bits  mm4=# of bits to shift

        psllw   mm2,8                           ; Shift lower byte into sra position
        psllw   mm3,8

        psraw   mm0,mm4                         ; SRA upper byte(s)
        psraw   mm1,mm4

        psraw   mm2,mm4                         ; SRA lower byte(s)
        psraw   mm3,mm4

        pand    mm0,lMaskHQ                     ; Clear lower debris bits
        pand    mm1,lMaskHQ     

        psrlw   mm2,8                           ; Shift lower byte(s) back to lower 8bit(s)
        psrlw   mm3,8

        por     mm0,mm2                         ; Blend upper/lower byte(s) into 16bits
        por     mm1,mm3

        movq    [edx+0],mm0                     ; Write Data
        movq    [edx+8],mm1

        ret
vmp_psraBAsmMMX endp



;_________________________________________________________________________________________________
;       Packed Shift Right Arithmetic 16x8bit by 1
;
;void vmp_psra1B( int8 * const pbD, const int8 * const pbA )
;{
;       int32 val, *pA;
;       uint32 *pD;
;
;       pA = (int32*)pbA;
;       pD = (uint32*)pbD;
;
;       val = *(pA+0);
;       *(pD+0) = (((uint32)((val<<24) >> 1)) >> 24)
;               | ((((uint32)((val<<16) >> 1)) >> 16) & 0x0000FF00)
;               | ((((uint32)((val<< 8) >> 1)) >>  8) & 0x00FF0000)
;               | ((val >> 1) & 0xFF000000);
;
;       val = *(pA+1);
;       *(pD+1) = (((uint32)((val<<24) >> 1)) >> 24)
;               | ((((uint32)((val<<16) >> 1)) >> 16) & 0x0000FF00)
;               | ((((uint32)((val<< 8) >> 1)) >>  8) & 0x00FF0000)
;               | ((val >> 1) & 0xFF000000);
;
;       val = *(pA+2);
;       *(pD+2) = (((uint32)((val<<24) >> 1)) >> 24)
;               | ((((uint32)((val<<16) >> 1)) >> 16) & 0x0000FF00)
;               | ((((uint32)((val<< 8) >> 1)) >>  8) & 0x00FF0000)
;               | ((val >> 1) & 0xFF000000);
;
;       val = *(pA+3);
;       *(pD+3) = (((uint32)((val<<24) >> 1)) >> 24)
;               | ((((uint32)((val<<16) >> 1)) >> 16) & 0x0000FF00)
;               | ((((uint32)((val<< 8) >> 1)) >>  8) & 0x00FF0000)
;               | ((val >> 1) & 0xFF000000);
;}
;       NOTE: As X86 packed shifting only supports 16/32/64 bits we have to mask for 8bit!
;
;       *** MMX version *** 128bit (un)aligned

        public  vmp_psra1BAsmMMX
vmp_psra1BAsmMMX       proc    near pbD:ptr, pbA:ptr, count:DWORD
        .MMX    
ASSERT_PTR(pbD)
ASSERT_PTR(pbA)

        mov     edx,pbD
        mov     eax,pbA

        movq    mm0,[eax+0]                     ; Read Data
        movq    mm1,[eax+8]

        ; mm0=64bits mm1=64bits

        movq    mm2,mm0
        movq    mm3,mm1

        pand    mm0,llMaskBQ[1*8]                       ;7F Strip lower bit
        pand    mm1,llMaskBQ[1*8]
        pand    mm2,llMaskBQ[7*8]                       ;80 Mask Upper bit
        pand    mm3,llMaskBQ[7*8]

        psrlq   mm0,1                           ; val >> 1
        psrlq   mm1,1

        por     mm0,mm2                         ; Blend Sticky (Sign) Bits
        por     mm1,mm3

        movq    [edx+0],mm0                     ; Write Data
        movq    [edx+8],mm1
                
        ret
vmp_psra1BAsmMMX        endp



;_________________________________________________________________________________________________
;=================================================================================================
;       Packed Shift Right Arithmetic 8x16bit by n:{0...15}
;
;void vmp_psraH( int16 * const phD, const int16 * const phA, uint count )
;{
;       int32 val, *pA;
;       uint32 *pD;
;
;       pA = (int32*)phA;
;       pD = (uint32*)phD;
;
;       count &= (16-1);                                // Clip count to data bit size -1
;
;       val = *(pA+0);
;       *(pD+0) = (((uint32)((val<<16) >> count)) >> 16)
;               | ((val >> count) & 0xFFFF0000);
;
;       val = *(pA+1);
;       *(pD+1) = (((uint32)((val<<16) >> count)) >> 16)
;               | ((val >> count) & 0xFFFF0000);
;
;       val = *(pA+2);
;       *(pD+2) = (((uint32)((val<<16) >> count)) >> 16)
;               | ((val >> count) & 0xFFFF0000);
;
;       val = *(pA+3);
;       *(pD+3) = (((uint32)((val<<16) >> count)) >> 16)
;               | ((val >> count) & 0xFFFF0000);
;}                                                                      
;       *** MMX version *** 128bit (un)aligned

        public  vmp_psraHAsmMMX
vmp_psraHAsmMMX       proc    near pwD:ptr, pwA:ptr, count:DWORD
        .MMX    
ASSERT_PTR(pwD)
ASSERT_PTR(pwA)

        mov     ecx,dword ptr count             ; # of bits to shift
        mov     edx,pwD
        mov     eax,pwA
        and     ecx,16-1                                ; Clip count to 0...7 bits

        movq    mm0,[eax+0]                     ; Read Data
        movq    mm1,[eax+8]                             
        movd    mm2,ecx

        ; mm0=64bits mm1=64bits  mm2=# of bits to shift

        psraw   mm0,mm2                         ; val >> count (0...15)
        psraw   mm1,mm2

        movq    [edx+0],mm0                     ; Write Data
        movq    [edx+8],mm1

        ret
vmp_psraHAsmMMX endp



;_________________________________________________________________________________________________
;       Packed Shift Right Arithmetic 8x16bit by 1
;
;void vmp_psra1H( int16 * const phD, const int16 * const phA )
;{
;       int32 val, *pA;
;       uint32 *pD;
;
;       pA = (int32*)phA;
;       pD = (uint32*)phD;
;
;       val = *(pA+0);
;       *(pD+0) = (((uint32)((val<<16) >> 1)) >> 16)
;               | ((val >> count) & 0xFFFF0000);
;
;       val = *(pA+1);
;       *(pD+1) = (((uint32)((val<<16) >> 1)) >> 16)
;               | ((val >> count) & 0xFFFF0000);
;
;       val = *(pA+2);
;       *(pD+2) = (((uint32)((val<<16) >> 1)) >> 16)
;               | ((val >> count) & 0xFFFF0000);
;
;       val = *(pA+3);
;       *(pD+3) = (((uint32)((val<<16) >> 1)) >> 16)
;               | ((val >> count) & 0xFFFF0000);
;}                                                                      
;       *** MMX version *** 128bit (un)aligned

        public  vmp_psra1HAsmMMX
vmp_psra1HAsmMMX       proc    near phD:ptr, phA:ptr, count:DWORD
        .MMX    
ASSERT_PTR(phD)
ASSERT_PTR(phA)

        mov     edx,phD
        mov     eax,phA

        movq    mm0,[eax+0]                     ; Read Data
        movq    mm1,[eax+8]

        ; mm0=64bits mm1=64bits

        psraw   mm0,1                           ; val >> 1
        psraw   mm1,1

        movq    [edx+0],mm0                     ; Write Data
        movq    [edx+8],mm1
                
        ret
vmp_psra1HAsmMMX        endp



;_________________________________________________________________________________________________
;=================================================================================================
;       Packed Shift Right Arithmetic 4x32bit by n:{0...31}
;
;void vmp_psraW( int32 * const pwD, const int32 * const pwA, uint count )
;{
;       count &= (32-1);                                // Clip count to data bit size -1
;
;       *(pwD+0) = (*(pwA+0)) >> count;
;       *(pwD+1) = (*(pwA+1)) >> count;
;       *(pwD+2) = (*(pwA+2)) >> count;
;       *(pwD+3) = (*(pwA+3)) >> count;
;}                                                                      
;       *** MMX version *** 128bit (un)aligned

        public  vmp_psraWAsmMMX
vmp_psraWAsmMMX       proc    near pwD:ptr, pwA:ptr, count:DWORD
        .MMX    
ASSERT_PTR(pwD)
ASSERT_PTR(pwA)

        mov     ecx,dword ptr count             ; # of bits to shift
        mov     edx,pwD
        mov     eax,pwA
        and     ecx,32-1                        ; Clip count to 0...7 bits

        movq    mm0,[eax+0]                     ; Read Data
        movq    mm1,[eax+8]                             
        movd    mm2,ecx

        ; mm0=64bits mm1=64bits  mm2=# of bits to shift

        psrad   mm0,mm2                         ; val >> count (0...15)
        psrad   mm1,mm2

        movq    [edx+0],mm0                     ; Write Data
        movq    [edx+8],mm1

        ret
vmp_psraWAsmMMX endp



;_________________________________________________________________________________________________
;       Packed Shift Right Arithmetic 4x32bit by 1
;
;void vmp_psra1W( int32 * const pwD, const int32 * const pwA )
;{
;       *(pwD+0) = (*(pwA+0)) >> 1;
;       *(pwD+1) = (*(pwA+1)) >> 1;
;       *(pwD+2) = (*(pwA+2)) >> 1;
;       *(pwD+3) = (*(pwA+3)) >> 1;
;}
;       *** MMX version *** 128bit (un)aligned

        public  vmp_psra1WAsmMMX
vmp_psra1WAsmMMX       proc    near pwD:ptr, pwA:ptr, count:DWORD
        .MMX    
ASSERT_PTR(pwD)
ASSERT_PTR(pwA)

        mov     edx,pwD
        mov     eax,pwA

        movq    mm0,[eax+0]                     ; Read Data
        movq    mm1,[eax+8]

        ; mm0=64bits mm1=64bits

        psrad   mm0,1                           ; val >> 1
        psrad   mm1,1

        movq    [edx+0],mm0                     ; Write Data
        movq    [edx+8],mm1
                
        ret
vmp_psra1WAsmMMX        endp



psraX86  ends
        end




