  
//
//  Pas.h - Packed Addition/Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 31 Dec 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions


#ifndef __Pas_H
#define __Pas_H

#ifdef __cplusplus
extern "C" {
#endif


    //  Addition (Un)signed

typedef void (*vmp_paddBProc)( uint8  * const pbD, const uint8  * const pbA, const uint8 * const pbB );
extern vmp_paddBProc vmp_paddB;
extern vmp_paddBProc vmp_paddB0;

typedef void (*vmp_paddHProc)( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
extern vmp_paddHProc vmp_paddH;
extern vmp_paddHProc vmp_paddH0;

typedef void (*vmp_paddWProc)( uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );
extern vmp_paddWProc vmp_paddW;
extern vmp_paddWProc vmp_paddW0;

    //  Subtraction (Un)signed

typedef void (*vmp_psubBProc)( uint8  * const pbD, const uint8  * const pbA, const uint8 * const pbB );
extern vmp_psubBProc vmp_psubB;
extern vmp_psubBProc vmp_psubB0;

typedef void (*vmp_psubHProc)( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
extern vmp_psubHProc vmp_psubH;
extern vmp_psubHProc vmp_psubH0;

typedef void (*vmp_psubWProc)( uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );
extern vmp_psubWProc vmp_psubW;
extern vmp_psubWProc vmp_psubW0;


    //  Addition Unsigned w/Saturation

typedef void (*vmp_paddusBProc)( uint8  * const pbD, const uint8  * const pbA, const uint8 * const pbB );
extern vmp_paddusBProc vmp_paddusB;
extern vmp_paddusBProc vmp_paddusB0;

typedef void (*vmp_paddusHProc)( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
extern vmp_paddusHProc vmp_paddusH;
extern vmp_paddusHProc vmp_paddusH0;

    //  Subtraction Unsigned w/Saturation

typedef void (*vmp_psubusBProc)( uint8  * const pbD, const uint8  * const pbA, const uint8 * const pbB );
extern vmp_psubusBProc vmp_psubusB;
extern vmp_psubusBProc vmp_psubusB0;

typedef void (*vmp_psubusHProc)( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
extern vmp_psubusHProc vmp_psubusH;
extern vmp_psubusHProc vmp_psubusH0;


    //  Addition signed w/Saturation

typedef void (*vmp_paddsBProc)( int8  * const pbD, const int8  * const pbA, const int8 * const pbB );
extern vmp_paddsBProc vmp_paddsB;
extern vmp_paddsBProc vmp_paddsB0;

typedef void (*vmp_paddsHProc)( int16 * const phD, const int16 * const phA, const int16 * const phB );
extern vmp_paddsHProc vmp_paddsH;
extern vmp_paddsHProc vmp_paddsH0;

    //  Subtraction signed w/Saturation

typedef void (*vmp_psubsBProc)( int8  * const pbD, const int8  * const pbA, const int8 * const pbB );
extern vmp_psubsBProc vmp_psubsB;
extern vmp_psubsBProc vmp_psubsB0;

typedef void (*vmp_psubsHProc)( int16 * const phD, const int16 * const phA, const int16 * const phB );
extern vmp_psubsHProc vmp_psubsH;
extern vmp_psubsHProc vmp_psubsH0;



#ifdef __cplusplus
}
#endif

#endif  //__Pas_H


