  
//
//  QVas3D.h - 3D (Quad) Math Addition & Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions
#include    "vmp3D.h"


#ifndef __QVas3D_H
#define __QVas3D_H

#ifdef __cplusplus
extern "C" {
#endif





//
//  Vector Summation (Addition)
//
typedef void (*vmp_QVecAddProc)(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
extern vmp_QVecAddProc vmp_QVecAdd;
extern vmp_QVecAddProc vmp_QVecAdd0;

//
//  Vector Difference (Subtraction)
//
typedef void (*vmp_QVecSubProc)(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
extern vmp_QVecSubProc vmp_QVecSub;
extern vmp_QVecSubProc vmp_QVecSub0;

//
//  Vector Scalar Summation (Addition)
//
typedef void (*vmp_QVecAddScalarProc)( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
extern vmp_QVecAddScalarProc vmp_QVecAddScalar;
extern vmp_QVecAddScalarProc vmp_QVecAddScalar0;

//
//  Vector Scalar Difference (Subtraction)
//
typedef void (*vmp_QVecSubScalarProc)( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
extern vmp_QVecSubScalarProc vmp_QVecSubScalar;
extern vmp_QVecSubScalarProc vmp_QVecSubScalar0;






#ifdef __cplusplus
}
#endif

#endif  //__QVas3D_H


