  
//
//  QVmd3DEx.h - (Quad) 3D Math Multiplication & Division
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "CpuAsm.h"
#include    "vmp3D.h"


#ifndef __QVmd3DEx_H
#define __QVmd3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void QVmd3DSetup( const CpuInfo * const pcinfo );

void vmp_QVecMulGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QVecMulAsm3DNow(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QVecMulAsmSSE(  vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QVecMulAsmSSE0( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);

void vmp_QVecScaleGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar );
void vmp_QVecScaleAsm3DNow(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar );
void vmp_QVecScaleAsmSSE(  vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar );
void vmp_QVecScaleAsmSSE0( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar );

void vmp_QVecMAddGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMAddAsm3DNow(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMAddAsmSSE(  vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMAddAsmSSE0( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);

void vmp_QVecMSubGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMSubAsm3DNow(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMSubAsmSSE(  vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMSubAsmSSE0( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);

void vmp_QVecDivGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecDivAsm3DNow(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecDivAsmSSE(  vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecDivAsmSSE0( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);

void vmp_QVecDivFastAsm3DNow(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecDivFastAsmSSE(  vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecDivFastAsmSSE0( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);

void vmp_QDotProductGeneric( float * const pfD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QDotProductAsm3DNow(float * const pfD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QDotProductAsmSSE(  float * const pfD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QDotProductAsmSSE0( float * const pfD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);

void vmp_QCrossProductGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QCrossProductAsm3DNow(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QCrossProductAsmSSE(  vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QCrossProductAsmSSE0( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);


#ifdef __cplusplus
}
#endif

#endif  //__QVmd3DEx_H


