        TITLE   BlitX86.asm - 80(x)86 Blit Code
        PAGE    53,160

;
;       Tabs = 8


        .XLIST

        .387
        .686P
        .MMX
        .model flat, C

 
        .LIST



        .data
;------------------------------------------------------------------------------------------------


foo		dd	0



BlitX86  SEGMENT USE32 PUBLIC 'CODE'



;-------------------------------------------------------------------------------------------------
;=================================================================================================
;
;void fnTBlitAsm( DWORD *pDst, const DWORD *pSrc, const DWORD *pTsp, uint nWidth, uint nHeight, int iDAdj, int iSAdj, int iTAdj, DWORD alphaValue, DWORD ckey )
;	uint w;
;
;	// check for invalid raster ops
;    do
;    {
;		w = nWidth;
;
;		do {
;			if (ckey != (*pTsp & 0x00FFFFFF))
;            {    
;					// no alpha
;				*pDst = *pSrc;
;            }
;
;			++pTsp;
;            ++pSrc;
;            ++pDst;
;        } while (--w);		 // for () each column in row
;
;		pTsp += iTAdj;
;		pSrc += iSAdj;
;		pDst += iDAdj;
;
;    } while (--nHeight); // for () each row
;
;
;	NOTE: pTsp is either pSrc or pDst,       and iTAdj corresponds similarly!
;


	align	16

        public  fnTBlitAsm
fnTBlitAsm    proc    near uses ebx esi edi, pDst:ptr, pSrc:ptr, pTsp:ptr, nWidth:DWORD, nHeight:DWORD, iDAdj:DWORD, iSAdj:DWORD, iTAdj:DWORD, alphaValue:DWORD, ckey:DWORD

	;	Adjust # of dwords for # of bytes!

	mov	ecx,nWidth
	shl	iSAdj,2
	shl	iDAdj,2

	mov	esi,pSrc
	mov	edi,pDst
	mov	edx,ckey

	; Is The source the transparency?

	cmp	esi,pTsp
	jne	$dr	; Jump if no!

;	______________________
;	Source is Transparency

$sr1:	mov	eax,[esi]	; Src

	mov	ebx,eax
	and	ebx,00FFFFFFh
	cmp	ebx,edx		; Transparency
	je	$sr2

	mov	[edi],eax	; Save Destination

$sr2:	add	esi,4
	add	edi,4

	dec	ecx		; --w
	jne	$sr1

	;	Next scanline 

	add	esi,iSAdj			; Src Stride Adjustment
	add	edi,iDAdj			; Dst Stride Adjustment

	mov	ecx,nWidth
	dec	nHeight
	jne	$sr1
	
	ret


;	___________________________
;	Destination is Transparency

$dr:
$dr1:	mov	ebx,[edi]	; dst
	mov	eax,[esi]	; src

	and	ebx,00FFFFFFh
	cmp	ebx,edx		; Transparency
	je	$dr2

	mov	[edi],eax	; Save destination

$dr2:	add	esi,4
	add	edi,4

	dec	ecx
	jne	$dr1

	;	Next scanline 

	add	esi,iSAdj			; Src Stride Adjustment
	add	edi,iDAdj			; Dst Stride Adjustment

	mov	ecx,nWidth
	dec	nHeight
	jne	$dr1
	
	ret
fnTBlitAsm  endp

	  

BlitX86  ends
        end

